#!/usr/bin/python

import sys
import string

input       = open(sys.argv[1], 'r')
output      = open(sys.argv[2], 'w')

startUsec   = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] 

endUsec     = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

indent      = "     "
indexIndent = 0

def FunctStart(indentIndex):
   spacer      = ""
   startMin    = 0
   startSec    = 0

   for i in range(indentIndex):
      spacer = spacer + indent
      
   index = string.find(line, "StartTime:")

   if index != -1:
      functName = line[12:index]
      
      if indentIndex == 0:
         output.write("\n\n")

      timeIndex   = index + len("StartTime:")
      funcTime    = line[timeIndex:-1]
      timeFields  = funcTime.split(":")
      startMin    = int(timeFields[1]) * 60 * 1000000
      startSec    = int(timeFields[2]) * 1000000
      startUsec[indentIndex] = int(timeFields[3]) + startMin + startSec

      output.write( "%s%s Start: %s\n" % (spacer, functName, funcTime) )
   
   indentIndex = indentIndex + 1
   return indentIndex
   

def FunctEnd(indentIndex):
   indentIndex = indentIndex - 1
   spacer      = ""
   endMin      = 0
   endSec      = 0
   
   for i in range(indentIndex):
      spacer = spacer + indent
   
   index = string.find(line, "StartTime:")
   
   if index != -1:
      functName = line[(len("FUNCT END")+1):index]

      timeIndex   = index + len("StartTime:")
      funcTime    = line[timeIndex:-1]
      timeFields  = funcTime.split(":")
      endMin      = int(timeFields[1]) * 60 * 1000000
      endSec      = int(timeFields[2]) * 1000000
      endUsec[indentIndex] = int(timeFields[3]) + endMin + endSec
      
      output.write( "%s%s run time: %d\n" % 
                     (spacer, functName, (endUsec[indentIndex] - startUsec[indentIndex])) )
   
   return indentIndex


for line in input.readlines():

   if line[:len("FUNCT START")] == "FUNCT START":
      indexIndent = FunctStart(indexIndent)

   elif line[:len("FUNCT END")] == "FUNCT END":
      indexIndent = FunctEnd(indexIndent)


