/***************************************************************************
                          carpics.cpp  -  description
                             -------------------
    begin                : Wed Jan 11 01:49:10 EDT 2003
    copyright            : (C) 2003 by Kevin Greenhaw
    email                : kevin_greenhaw@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>

#include "carpics.h"

char RaceCarImage::CAR_COLOR[12] = {"o c #000000"};

/* XPM */
const char *RaceCarImage::CarPic00[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   "O c #777777",
   CAR_COLOR,
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "+++++ooooooooo++++++",
   "+++++ooooooooo++++++",
   "+++++X XoooX X++++++",
   "+++++   ooo   ++++++",
   "+++++   oXo   ++++++",
   "+++++X oXOXo X++++++",
   "+++++ooXOOOXoo++++++",
   "++++oooXOOOXooo+++++",
   "++++oooXOOOXooo+++++",
   "++++ooooXOXoooo+++++",
   "++++oooooXooooo+++++",
   "++++   XoooX   +++++",
   "++++   .ooo.   +++++",
   "++++   .ooo.   +++++",
   "++++   XoooX   +++++",
   "++++oooXoooXooo+++++",
   "++++ooooooooooo+++++",
   "++++ooooooooooo+++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic01[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++ooo++++++++++",
   "+++++++ooooooo++++++",
   "+++++++o.Xoooooo++++",
   "+++++++  Xoooooo++++",
   "++++++   XooX. o++++",
   "++++++o XXoo.  +++++",
   "+++++oooXXOXX  +++++",
   "+++++oooOOOOo.X+++++",
   "++++ooooOOOOooo+++++",
   "++++ooooXOOXooo+++++",
   "++++XXoooOXoooo+++++",
   "+++   .oooooooo+++++",
   "+++   XooooXXoo+++++",
   "+++   Xoooo.  ++++++",
   "+++X..ooooX   ++++++",
   "++ooooXoooX   ++++++",
   "++ooooooooXX. ++++++",
   "++++ooooooooo+++++++",
   "+++++++oooooo+++++++",
   "+++++++++++oo+++++++"
};

/* XPM */
const char *RaceCarImage::CarPic02[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++oo++++++++",
   "+++++++++Xoooo++++++",
   "+++++++++. ooooo++++",
   "++++++++   Xooooo+++",
   "++++++++X  ooooooo++",
   "++++++ooXXXooo. X+++",
   "+++++ooooXOOX.  .+++",
   "+++++ooooOOOXo  ++++",
   "++++XoooXOOOXo.X++++",
   "++++ .oooOOOXoo+++++",
   "+++   XooXXoooo+++++",
   "++   .Xoooooooo+++++",
   "++X. XoooooXooo+++++",
   "+oooXXoooo...o++++++",
   "+ooooooooX   +++++++",
   "++ooooooX.   +++++++",
   "++++oooooX. ++++++++",
   "++++++oooooX++++++++",
   "+++++++oooo+++++++++",
   "+++++++++oo+++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic03[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++++++++o++++++",
   "++++++++++++ooo+++++",
   "+++++++++++. ooo++++",
   "++++++++++  .oooo+++",
   "+++++++o+o.  ooooo++",
   "++++++ooooXXooooooo+",
   "+++++oooooXOXooXXXo+",
   "++++ XoooXOOOX.  X++",
   "+++   XooOOOOo.  +++",
   "++    .ooXOOOoX.++++",
   "+oX  .oooXXXooo+++++",
   "oooX.oooooooooo+++++",
   "ooooooooooooooo+++++",
   "+oooooooo. Xoo++++++",
   "++oooooo.   X+++++++",
   "+++ooooX    ++++++++",
   "++++ooooX  +++++++++",
   "+++++ooooX++++++++++",
   "++++++ooo+++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic04[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "+++++++++++++++o++++",
   "+++++++++++++.ooo+++",
   "++++++++++++   oo+++",
   "++++++++oooX. .ooo++",
   "++++++oooooXX Xoooo+",
   "++++  XooooXXoooooo+",
   "+++    oooXOOOoooooo",
   "+oo   .oooOOOOo...oo",
   "oooX XXooXOOOXo  .X+",
   "+oooooooooXOXoX.  ++",
   "+ooooooooooooooX++++",
   "++ooooooXoooooo+++++",
   "++oooooX. Xooo++++++",
   "+++oooX    oo+++++++",
   "++++ooo.   +++++++++",
   "++++oooX +++++++++++",
   "+++++oo+++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic05[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "+++++++++++++++.oo++",
   "++++++++ooooo. ..oo+",
   "++++   XooooX   Xoo+",
   "+ooX .  ooooXo..ooo+",
   "+ooo   .oooXOXoooooo",
   "+oooXXXoooOOOOOooooo",
   "+oooXooooXOOOOXX.ooo",
   "++ooooooooXOXOo   Xo",
   "++oooooooooooo.. .oo",
   "++oooXXXXXooooo. +++",
   "++oooX.  .oooo++++++",
   "+++ooo    ooo+++++++",
   "+++ooo.  +++++++++++",
   "+++ooo++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic06[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   "O c #777777",
   CAR_COLOR,
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "+ooo    oooo++++++++",
   "+ooo    oooooX  Xoo+",
   "+ooo    ooooo    oo+",
   "+ooX..XoooXXXo  Xoo+",
   "+ooooooooXOOOXooooo+",
   "+oooooooXOOOOOXoooo+",
   "+ooooooooXOOOXooooo+",
   "+ooX..XoooXXXo  Xoo+",
   "+ooo    ooooo    oo+",
   "+ooo   OoooooX  Xoo+",
   "+ooo    oooo++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic07[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "+++ooo++++++++++++++",
   "+++ooX   .++++++++++",
   "++ooo.   Xooo+++++++",
   "++ooo..  Xoooo++++++",
   "++ooooXXXoooooX. +++",
   "+ooooooooooXoo   Xoo",
   "+oooooooooOOOoX  Xoo",
   "+ooooooooOOOOXoXXooo",
   "+ooX..XooXOOOOXoooo+",
   "oooX   XooXXOoooooo+",
   "+oo.   XooooXX Xooo+",
   "++++   oooooX   Xoo+",
   "++++++++ooo+o  .oo++",
   "++++++++++++++++oo++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic08[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++o++++++++++++++",
   "+++++ooo++++++++++++",
   "++++oooX  ++++++++++",
   "++++ooo    +++++++++",
   "+++oooX.   oo+++++++",
   "++ooooooX Xoooo+++++",
   "++ooooooooooooo+++++",
   "+ooooooooooooooo++++",
   "+oooXooooXXOXXX.  ++",
   "oooX .XoooOOOOo   oo",
   "+oo    XooOOOOo...oo",
   "+++    oooOOOOoooooo",
   "+++++ XooooooXooooo+",
   "+++++++ooooX. .oooo+",
   "++++++++oooX. .ooo++",
   "++++++++++++  .Xo+++",
   "++++++++++++++ooo+++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic09[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++ooo++++++++++",
   "++++++oooo.+++++++++",
   "+++++oooo.  ++++++++",
   "++++ooooX    +++++++",
   "+++oooooo.  .o++++++",
   "++oooooooX..Xoo+++++",
   "+ooooooooooooooo++++",
   "+ooo..Xooooooooo++++",
   "++o.  .oooXXXooo++++",
   "+++    XooOOOXo..+++",
   "++++  .XoXOOOOo   ++",
   "+++++.ooooXOOOX.  o+",
   "++++++oooooXXXooXXoo",
   "+++++++ooooXXooooooo",
   "++++++++++X  .ooooo+",
   "+++++++++++  .oooo++",
   "++++++++++++..ooo+++",
   "+++++++++++++ooo++++",
   "++++++++++++++o+++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic10[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++++ooo++++++++",
   "+++++++oooooo+++++++",
   "+++++oooooo. +++++++",
   "++++oooooo.   ++++++",
   "++ooooooooX    +++++",
   "++ooooXooooX .X+++++",
   "+++o. .oooooXooo++++",
   "++++   Xoooooooo++++",
   "++++   .ooXXooooo+++",
   "+++++ .XooOOOXoo++++",
   "+++++.ooooOOOXoXX+++",
   "++++++ooooOOOOo  +++",
   "++++++ooooXOOOX  .++",
   "+++++++oooXooXo. .o+",
   "+++++++++X  Xoooooo+",
   "+++++++++   Xoooooo+",
   "++++++++++  Xoooo+++",
   "++++++++++oXooo+++++",
   "+++++++++++ooo++++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic11[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++++++oooo+++++",
   "+++++++oooooooo+++++",
   "++++ooooooooooX+++++",
   "++++oooooooo.  +++++",
   "++++ooXXoooo.   ++++",
   "++++X  .ooooX   ++++",
   "+++++  .Xoooo ..++++",
   "+++++   Xooooooo++++",
   "+++++  .oooXooooo+++",
   "++++++ooooXOXoooo+++",
   "++++++oooXOOOXooo+++",
   "++++++ooooOOOXoo++++",
   "++++++ooooXOOXX..+++",
   "++++++++X.oXOo   +++",
   "++++++++X .ooo. .+++",
   "++++++++   XooX.Xo++",
   "++++++++. .ooooooo++",
   "+++++++++oXoooooo+++",
   "+++++++++ooooo++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic12[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   "O c #777777",
   CAR_COLOR,
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "+++++ooooooooooo++++",
   "+++++ooooooooooo++++",
   "+++++oooXoooXooo++++",
   "+++++   .ooo.   ++++",
   "+++++   .ooo.   ++++",
   "+++++   XoooX   ++++",
   "+++++   ooooo   ++++",
   "+++++oooooXooooo++++",
   "+++++ooooXOXoooo++++",
   "+++++oooXOOOXooo++++",
   "+++++oooXOOOXooo++++",
   "++++++ooXOOOXoo+++++",
   "++++++X oXOXo X+++++",
   "++++++   oXo   +++++",
   "++++++   ooo   +++++",
   "++++++X XoooX X+++++",
   "++++++ooooooooo+++++",
   "++++++ooooooooo+++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic13[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++ooo++++++++++",
   "+++++++ooooooo++++++",
   "+++++++oooooooooo+++",
   "+++++++ .XXooooooo++",
   "++++++   .ooooXooo++",
   "++++++   Xoooo...X++",
   "++++++.  ooooo   +++",
   "++++++oXXooooX   +++",
   "+++++ooooooooX   +++",
   "+++++ooooXOOoooX++++",
   "+++++oooXOOOoooo++++",
   "++++++ooXOOOXooo++++",
   "+++++X.XXOOOoooo++++",
   "+++++  .oOXoXo++++++",
   "+++++  .oXo. X++++++",
   "++++o..XooX   ++++++",
   "++++ooooooo   ++++++",
   "++++oooooooXX+++++++",
   "+++++++oooooo+++++++",
   "+++++++++++oo+++++++"
};

/* XPM */
const char *RaceCarImage::CarPic14[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++oo++++++++",
   "+++++++++ooooo++++++",
   "+++++++++.oooooo++++",
   "++++++++   Xooooo+++",
   "++++++++   Xooooooo+",
   "+++++++.  .ooooooooo",
   "++++++ooX ooooo.Xoo+",
   "++++++ooooooooX   X+",
   "+++++ooooooooo.   ++",
   "++++++oooXXOoo   +++",
   "+++++oooXOOOoooX +++",
   "+++++. oOOOOoooo++++",
   "++++   oXOOXoooo++++",
   "++++.  oXOooooo+++++",
   "+++oX.XoooX X+++++++",
   "+++oooooo.  X+++++++",
   "++++oooooX  ++++++++",
   "++++++oooX..++++++++",
   "+++++++oooo+++++++++",
   "+++++++++oo+++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic15[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++++++++o++++++",
   "++++++++++++ooo+++++",
   "+++++++++++.oooo++++",
   "++++++++++  .oooo+++",
   "+++++++++   .Xoooo++",
   "++++++++o. .Xoooooo+",
   "+++++++ooo.Xoooooooo",
   "++++++ooooooooooXooo",
   "++++++oooooooooX..oo",
   "+++++oooXOOOooo   .+",
   "++++ ..XXOOOoo.   ++",
   "+++.  .oOOOOooo  +++",
   "++oX  XXOOOXoooo++++",
   "++ooXoooXoooooo+++++",
   "++ooooooX..ooo++++++",
   "+++ooooo   o++++++++",
   "++++oooo   +++++++++",
   "+++++oooX.++++++++++",
   "++++++ooo+++++++++++",
   "++++++++++++++++++++"
};

/* XPM */
const char *RaceCarImage::CarPic16[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "+++++++++++++++o++++",
   "+++++++++++++Xooo+++",
   "++++++++++++  ooo+++",
   "++++++++++    .ooo++",
   "++++++++ooX  ..oooo+",
   "+++++++oooo..Xooooo+",
   "+++++++ooooooooooooo",
   "+++++.Xooooooooooooo",
   "+++.  .oXOOXooooXXoo",
   "+oo.  XXOOOOooo.  oo",
   "+ooX..oXOOOOoo    .o",
   "++oooooXXOXoooX   ++",
   "++oooooooXooooo.++++",
   "+++oooX  .ooooo+++++",
   "++++ooX  .o+o+++++++",
   "++++ooX. +++++++++++",
   "+++++oo+++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic17[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "+++++++++++++++Xoo++",
   "++++++++++++   .ooo+",
   "++++++++oooX   .ooo+",
   "++++++++oooo  ..Xoo+",
   "++++  XooooooXXXoooo",
   "+ooX.  XoXoooooooooo",
   "+ooX  .oXOOOoooooooo",
   "++oooXoXOOOOoooooXoo",
   "++ooooXOOOOOooXX.Xoo",
   "++oooooXXXXooX   .oo",
   "++oooX..Xooooo    oo",
   "+++oo.  .ooooo.  +++",
   "+++ooX  X+ooo+++++++",
   "+++ooo++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic18[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   "O c #777777",
   CAR_COLOR,
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++oooo    ooo+",
   "+ooX  Xooooo    ooo+",
   "+oo    ooooo    ooo+",
   "+ooX  oXXXoooX..Xoo+",
   "+oooooXOOOXoooooooo+",
   "+ooooXOOOOOXooooooo+",
   "+oooooXOOOXoooooooo+",
   "+ooX  oXXXoooX..Xoo+",
   "+oo    ooooo    ooo+",
   "+ooX  XoooooO   ooo+",
   "++++++++oooo    ooo+",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic19[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++ooo.++++++++++++++",
   "++oo.  Xooooo+++++++",
   "++oo.   ooooo.   +++",
   "+oooX.Xoooooo    ooo",
   "+ooooooOOXooX.  .ooo",
   "+oooooOOOOXoooXXXooo",
   "+ooX.XXOOOOoooooooo+",
   "ooX  .oXOOXoooooooo+",
   "+oo  .Xoooooooooooo+",
   "++++ XoooooXXXXoooo+",
   "+++++++oooo    ooo++",
   "++++++++ooX   .ooo++",
   "++++++++++++  .ooo++",
   "+++++++++++++++oo+++",
   "++++++++++++++++++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic20[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++++++++++++++++",
   "++++oo++++++++++++++",
   "++++ooX+++++++++++++",
   "+++ooX  .+++++++++++",
   "++oooX   oooo+++++++",
   "++ooooX.XoooooX+++++",
   "+ooooooXXXoooo  ++++",
   "+ooXXoXOOOXoo.    ++",
   "oo.. .oOOOOooX.  Xoo",
   "+oX  .XOOOOXooX..ooo",
   "+++ ..ooXXoooooXXooo",
   "+++++oooooooooooooo+",
   "++++++ooooXXooooooo+",
   "++++++oooo ..Xoooo++",
   "++++++++o.    ooo+++",
   "++++++++++   Xooo+++",
   "++++++++++++.ooo++++",
   "+++++++++++++ooo++++",
   "++++++++++++++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic21[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "++++++++++++++++++++",
   "++++++oo++++++++++++",
   "+++++oooX+++++++++++",
   "++++ooo . ++++++++++",
   "+++oooo.  X+++++++++",
   "++oooooX. Xoo+++++++",
   "+oooooooXooooo++++++",
   "+oo..XoOOOooooo+++++",
   "++X.  XOOOOoooX ++++",
   "+++  .oOOOOXoX   +++",
   "++++XXooOOOooo.  .++",
   "+++++oooXooXooO. Xo+",
   "+++++ooooooooooXXooo",
   "++++++oooXXooooooooo",
   "+++++++oX .Xooooooo+",
   "++++++++   .Xooooo++",
   "+++++++++   Xoooo+++",
   "++++++++++ Xoooo++++",
   "+++++++++++oooo+++++",
   "++++++++++++oo++++++"
};


/* XPM */
const char *RaceCarImage::CarPic22[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++++o++++++++++",
   "+++++++oooo+++++++++",
   "+++++ooooXX+++++++++",
   "++++ooooo   ++++++++",
   "++ooooooX  .++++++++",
   "++ooXXooo...o+++++++",
   "+++X  XoXXXoooo+++++",
   "++++  .XOOXoooo+++++",
   "++++ .XXOOOXoooo++++",
   "+++++ooXOOOXooo.++++",
   "+++++oooXOOXoX   +++",
   "+++++ooooooooo   +++",
   "+++++oooooooooO  .++",
   "++++++oo.XooooX Xoo+",
   "++++++X.  Xoooooooo+",
   "+++++++   .oooooooo+",
   "++++++++  .Xooooo+++",
   "++++++++ Xooooo+++++",
   "+++++++++ooooo++++++",
   "+++++++++ooo++++++++"
};


/* XPM */
const char *RaceCarImage::CarPic23[] = {
   /* columns rows colors static chars-per-pixel */
   "20 20 6 1",
   "  c #010101",
   ". c #484848",
   "X c #A6A6A6",
   CAR_COLOR,
   "O c #777777",
   "+ c None",
   /* pixels */
   "+++++++++++o++++++++",
   "+++++++oooooo+++++++",
   "++++oooooooXX+++++++",
   "++++ooooooX .+++++++",
   "++++o.XXooX   ++++++",
   "++++.  .ooX. X++++++",
   "+++++  .XOXoXo++++++",
   "+++++X oXOOXooo+++++",
   "+++++ooXOOOOoooo++++",
   "+++++oooXOOOoooo++++",
   "+++++ooooXOooooX++++",
   "+++++oooooXooX  ++++",
   "+++++ooooooooX   +++",
   "++++++. .ooooX   +++",
   "++++++   XoooX. .+++",
   "++++++   Xoooooooo++",
   "++++++  .Xoooooooo++",
   "+++++++oooooooooo+++",
   "+++++++ooooooo++++++",
   "+++++++ooo++++++++++"
};

RaceCarImage::RaceCarImage(char *CarColor) 
{
   int loopIndex = 0;

   sprintf(CAR_COLOR, "o c %s", CarColor);
   
   RaceCarList.append( new QPixmap(CarPic00) );
   RaceCarList.append( new QPixmap(CarPic01) );
   RaceCarList.append( new QPixmap(CarPic02) );
   RaceCarList.append( new QPixmap(CarPic03) );
   RaceCarList.append( new QPixmap(CarPic04) );
   RaceCarList.append( new QPixmap(CarPic05) );
   RaceCarList.append( new QPixmap(CarPic06) );
   RaceCarList.append( new QPixmap(CarPic07) );
   RaceCarList.append( new QPixmap(CarPic08) );
   RaceCarList.append( new QPixmap(CarPic09) );
   RaceCarList.append( new QPixmap(CarPic10) );
   RaceCarList.append( new QPixmap(CarPic11) );
   RaceCarList.append( new QPixmap(CarPic12) );
   RaceCarList.append( new QPixmap(CarPic13) );
   RaceCarList.append( new QPixmap(CarPic14) );
   RaceCarList.append( new QPixmap(CarPic15) );
   RaceCarList.append( new QPixmap(CarPic16) );
   RaceCarList.append( new QPixmap(CarPic17) );
   RaceCarList.append( new QPixmap(CarPic18) );
   RaceCarList.append( new QPixmap(CarPic19) );
   RaceCarList.append( new QPixmap(CarPic20) );
   RaceCarList.append( new QPixmap(CarPic21) );
   RaceCarList.append( new QPixmap(CarPic22) );
   RaceCarList.append( new QPixmap(CarPic23) );

   // Add 24 Entries to the Computer Controlled Car Hot Spot List
   for (loopIndex = 0; loopIndex < 24; loopIndex++)
   {
      ComputerHotSpots.append( new QPoint(10,10) );
   }

   // Add 24 Entries to the User Controlled Car Hot Spot List
   for (loopIndex = 0; loopIndex < 24; loopIndex++)
   {
      UserHotSpots.append( new QPoint(0,0) );
   }
}
