/***************************************************************************
                          zscreen.cpp  -  description
                             -------------------
    begin                : Wed Aug 21 01:49:10 EDT 2002
    copyright            : (C) 2002 by Kevin Greenhaw
    email                : kevin_greenhaw@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __END_SCREEN_H__
#define __END_SCREEN_H__

#include <qwidget.h>
#include <qcanvas.h>
#include <qimage.h>
#include <qpainter.h>

#include <qglobal.h>

class EndScreen : public QWidget
{
    Q_OBJECT

public:
   EndScreen(QCanvas& c, QWidget *parent = 0, const char *name = 0);
   
   void Show(bool   Winner, 
             int    RaceTrack, 
             int    Laps, 
             double FinishTime, 
             double RecordTime);
             
   void Hide();
   void keyPressEvent();

signals:
   void ReturnToStart();

private:
   QCanvas&     canvas;
   QCanvasView *editor;
   QCanvasText *RestartString;

   QCanvasText *LapsText;
   QCanvasText *FinishTimeText;
   QCanvasText *ALSStringText; 
   QCanvasText *RecordText;  
                  
   QCanvasPolygonalItem *FinishImage;   
};

#endif
