#ifndef __ZRALLY_IMAGES_H__
#define __ZRALLY_IMAGES_H__

#include <qimage.h>

class ZRallyImages
{
public:
   ZRallyImages();

   enum ZIMAGE {
      LOGO,
      RACE_WON,
      RACE_LOST,
      TRACK_NOT_AVAIL
   };

   QImage GetImage(ZIMAGE) const;

private:
   static const char *startLogo[];
   static const char *raceCompleted[];
   static const char *raceWon[];
   static const char *trackNotAvailable[];
};

extern ZRallyImages *zrallyImages;

#endif
